﻿Imports ThinkGeo.MapSuite.Core
Imports System.Collections.ObjectModel


Public Class Form1

   Private Sub btnCreateShapeFile_Click(sender As System.Object, e As System.EventArgs) Handles btnCreateShapeFile.Click
      Dim sFile As String = "c:\temp\PointLayer.SHP"
      Dim sMsg As String = ""
      Dim oPoints As ShapeFileFeatureLayer = Nothing

      If CreateTheShapeFile(sFile, 4269, sMsg) Then
         oPoints = New ShapeFileFeatureLayer(sFile, ShapeFileReadWriteMode.ReadWrite)
         If oPoints.IsOpen = False Then
            Try
               oPoints.Open()
               MessageBox.Show("We created and opened the Shape File", "SUCCESS!")
            Catch ex As Exception
               sMsg = "Unable to open the ShapeFile due to error:" + vbCrLf + ex.Message
               MessageBox.Show(sMsg, "Open Shape File Failed")
            End Try
         End If
      Else
         MessageBox.Show(sMsg, "CreateTheShapeFile Failed")
      End If
   End Sub
   Private Function CreateTheShapeFile(ByVal sShapeFilePath As String, ByVal iSRID As Integer, ByRef sErrMsg As String) As Boolean
      Dim bReturn As Boolean = True
      Dim oDbfColumns As Collection(Of DbfColumn)
      Dim oDbfColumn As DbfColumn = Nothing
      Dim sPrjText As String = ""
      oDbfColumns = New Collection(Of DbfColumn)


      oDbfColumn = New DbfColumn("NAME", DbfColumnType.String, 25, 0)
      oDbfColumns.Add(oDbfColumn)
      oDbfColumn = New DbfColumn("UniqueID", DbfColumnType.Integer, 10, 0)
      oDbfColumns.Add(oDbfColumn)
      oDbfColumn = New DbfColumn("LineNumber", DbfColumnType.Integer, 10, 0)
      oDbfColumns.Add(oDbfColumn)
      oDbfColumn = New DbfColumn("PlotNumber", DbfColumnType.Integer, 10, 0)
      oDbfColumns.Add(oDbfColumn)
      oDbfColumn = New DbfColumn("X", DbfColumnType.Double, 12, 8)
      oDbfColumns.Add(oDbfColumn)
      oDbfColumn = New DbfColumn("Y", DbfColumnType.Double, 12, 8)
      oDbfColumns.Add(oDbfColumn)
      oDbfColumn = New DbfColumn("TallyTHght", DbfColumnType.Logical, 1, 0)
      oDbfColumns.Add(oDbfColumn)

      Try
         sErrMsg = ""
         ShapeFileFeatureLayer.CreateShapeFile(ThinkGeo.MapSuite.Core.ShapeFileType.Point, sShapeFilePath, oDbfColumns, System.Text.Encoding.ASCII, OverwriteMode.Overwrite)
         'Try
         '   '***** Need to create a prj file to go with the new structure
         '   'sPrjText = ManagedProj4Projection.ConvertEpsgToPrj(iSRID)
         '   'File.WriteAllText(sShapeFilePath.ToUpper.Replace(".SHP", ".PRJ"), sPrjText)
         '   'MapUtilities.LayerUtils.CreatePrjFile(iSRID, Path.ChangeExtension(sShapeFilePath, ".prj"))
         'Catch ex As Exception
         '   sErrMsg = "Create the .PRJ Failed:" + vbCrLf + ex.Message
         '   bReturn = False
         'End Try
      Catch ex As Exception
         sErrMsg = "Create the .SHP Failed:" + vbCrLf + ex.Message
         bReturn = False
      End Try

      'After we create the Shape File, we need to verify that it was infact created...
      bReturn = System.IO.File.Exists(sShapeFilePath)

      Return bReturn
   End Function

End Class
